local addonInfo, privateVars = ...

if nkPanelPlanarCharges ~= nil then return end
nkPanelPlanarCharges = {}

function nkPanelPlanarCharges.main(_, addon)

	if addon == addonInfo.identifier then
	
		nkPanel.api.registerPlugin('Planar charges plugin', nkPanelPlanarCharges.plugin())
	end
	
end

Command.Event.Attach(Event.Addon.Load.End, nkPanelPlanarCharges.main, "nkPanelPlanarCharges.Addon.Load.End")

--------------------------------------------------------------------------------------------------------------------------------------------

function nkPanelPlanarCharges.plugin()
		
	local plugin = nkPanel.api.plugin('Planar charges plugin', true, false)
	local playerUNID
	local planar, planarMax = 0,0 

	plugin:SetTitle(string.format(nkPanelPlanarCharges.langTexts.title, 0, 0))
	
	plugin:SetThumb('Rift', 'chargedstone_on.png.dds')
	
	local function playerReady (_, units)
	
		if playerUNID == nil then
			local details = Inspect.Unit.Detail('player')
			if details ~= nil then playerUNID = details.id end
			if playerUNID == nil then return end
		end
		
		if units[playerUNID] == nil then return end

		local details = Inspect.Unit.Detail(playerUNID)
		if details ~= nil then
			planar = details.planar
			planarMax = details.planarMax		
			plugin:SetTitle(string.format(nkPanelPlanarCharges.langTexts.title, details.planar, details.planarMax))
		end
		
		local function planarChange(_, units)
			if units[playerUNID] == nil then return end
			planar = units[playerUNID]
			
			plugin:SetTitle(string.format(nkPanelPlanarCharges.langTexts.title, planar, planarMax))
		end
		
		local function planarMaxChange (_, units)
			if units[playerUNID] == nil then return end
			planarMax = units[playerUNID]
			
			plugin:SetTitle(string.format(nkPanelPlanarCharges.langTexts.title, planar, planarMax))
		end
		
		Command.Event.Attach(Event.Unit.Detail.Planar, planarChange, "nkPanelPlanarCharges.Unit.Detail.Planar")
		Command.Event.Attach(Event.Unit.Detail.PlanarMax, planarMaxChange, "nkPanelPlanarCharges.Unit.Detail.PlanarMax")
		

		Command.Event.Detach(Event.Unit.Availability.Full, nil, "nkPanelPlanarCharges.Unit.Availability.Full")
	end
	
	Command.Event.Attach(Event.Unit.Availability.Full, playerReady, "nkPanelPlanarCharges.Unit.Availability.Full")
	
	return plugin

end